
from google.appengine.api import users
from google.appengine.ext import webapp

from google.appengine.ext.webapp import template

from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.ext import db

import os


from google.appengine.api import mail


class EmailGuardStub(webapp.RequestHandler):
  def post(self):
    #self.response.out.write("%d"% len(self.request.POST.get('email')))
    self.response.out.write(self.request.POST.get('email'))
    #self.response.out.write('EmailGuardStub OK')
    
class EmailGuard(webapp.RequestHandler):
  def post(self):
    #self.response.out.write('  is not a valid email address!' )
    if len(self.request.get('email'))==0:
      return
    syn = "(?:[a-z0-9!#$%&'*+/=?^_{|}~-]+(?:.[a-z0-9!#$%" + \
    "&'*+/=?^_{|}~-]+)*|\"(?:" + \
    "[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]" + \
    "|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*\")@(?:(?:[a-z0-9]" + \
    "(?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?" + \
    "|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.)" + \
    "{3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?" + \
    "|[a-z0-9-]*[a-z0-9]:(?:" + \
    "[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]"  + \
    "|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])"
    syn_comp = re.compile(syn)
    if not syn_comp.match(self.request.get('email')):
      self.response.out.write('%s is not a valid email address!'% self.request.get('email'))
      return
    
    item = GuestbookItem()

    item.email = self.request.get('email')
    item.put()
    path = os.path.join(os.path.dirname(__file__), 'template/email.txt')
    
    template_values = {}

    mail.send_mail(sender="haifeng.gong@gmail.com",
              to=item.email, cc='harry.potter.gong@gmail.com',
              subject="[appspot] Haifeng's contact information",
              body= template.render(path, template_values))
    self.response.out.write('My email address has been sent to %s!'% item.email)
    
class EmailInputPage(webapp.RequestHandler):
  def get(self):
    template_values = {};
    path = os.path.join(os.path.dirname(__file__), 'template/email_input.html')
    self.response.out.write(template.render(path, template_values))

    
application = webapp.WSGIApplication([('/email', EmailGuardStub),
                                     ('/email_input', EmailInputPage)],
                                     debug=True)

def main():
  run_wsgi_app(application)

if __name__ == "__main__":
  main()
  
 
